Attribute VB_Name = "CardMod"

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'REDOX OnLine 1.1
'Copyright (C) 2004 Kenny TM~
' 
'This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 
' 
'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
'of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 
' 
'You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software
'Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Enum CardSuit
  ecsCLUBS = 0
  ecsDIAMONDS
  ecsHEARTS
  ecsSPADES
  ecsUNKNOWN
End Enum

Enum CardFace
  ecfA = 0
  ecf2
  ecf3
  ecf4
  ecf5
  ecf6
  ecf7
  ecf8
  ecf9
  ecf10
  ecfJ
  ecfQ
  ecfK
End Enum

Enum CardBack
  ecbCROSSHATCH = 53
  ecbWEAVE1
  ecbWEAVE2
  ecbROBOT
  ecbFLOWERS
  ecbVINE1
  ecbVINE2
  ecbFISH1
  ecbFISH2
  ecbSHELLS
  ecbCASTLE
  ecbISLAND
  ecbCARDHAND
  ecbUNUSED
  ecbTHE_X
  ecbTHE_O
End Enum

Public Enum PlotTypes
  eptUndefinied
  eptRoyalFlush
  eptMultiple
End Enum

Public Type RedoxPlot
  PlotType As PlotTypes
  MultipleFace As CardFace
  RoyalSuit As CardSuit
  RoyalLow As CardFace
  RoyalHigh As CardFace
  CardNum As Integer
End Type

Public Type MsgQueue
  sMsg As String
  iID As Integer
End Type

Public Type ScoreAssignment
  sName As String
  iScore As Long
  iID As Integer
End Type

Public Type OpenFileName
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Public Declare Sub InitCommonControls Lib "comctl32.dll" ()
Public Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OpenFileName) As Long
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OpenFileName) As Long
Public Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long
Public Declare Function WinHelp Lib "user32.dll" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long


Public CardWidth As Single, CardHeight As Single
'Public CurrentCardBack As CardBack
Public CurrentCardID As Byte, CardsID(1 To 15) As Byte
Public CardSelected(1 To 15) As Boolean
Public DiscardCard As Long, DrawCard As Long
Public TotalSelected As Byte, HavePlot As Boolean, TotalCards As Byte
Public Plots(1 To 128) As RedoxPlot, NumOfPlot As Byte
Public OtherPlayersName(1 To 32) As String
Public CurrentPlayers As Byte 'OtherPlayersCards(1 To 32, 1 To 15) As Byte
Public Scores As Long, MyID As Byte, CurrentPlayerID As Byte
Public CurrentServer As String

Public TempRetVal As String, TempMyName As String, TempPort As Integer
Public NoPlayer As Integer

Public RoundPlaying As Boolean

Public ClockwiseDir As Boolean, LockedOut As Boolean

Public UltimateClose As Boolean

Public TransferBuffer(1 To 32) As String

Public SendQueue() As MsgQueue
Public CurrentQueueSize As Integer

Public SaveScores As Boolean
Public AllScoresReload() As ScoreAssignment

Public CVotes As Integer, CVAgrees As Integer, LastVoteFor As String

Public LastWinner As Integer

Private Sub Enqueue2(Msg3 As MsgQueue)
  CurrentQueueSize = CurrentQueueSize + 1
  ReDim Preserve SendQueue(CurrentQueueSize)
  SendQueue(CurrentQueueSize) = Msg3
End Sub

Public Sub Enqueue(Message As String, Socket As Integer)
  Dim Msg4 As MsgQueue
  Msg4.sMsg = Message
  Msg4.iID = Socket
  Enqueue2 Msg4
End Sub

Public Function Dequeue() As MsgQueue
  Dim I As Integer
  '
  Dequeue = SendQueue(0)
  
  'GetQueue SendQueue(0).sMsg, SendQueue(0).iID
  
  For I = 1 To CurrentQueueSize
    SendQueue(I - 1) = SendQueue(I)
  Next
  CurrentQueueSize = CurrentQueueSize - 1
  If CurrentQueueSize >= 0 Then
    ReDim Preserve SendQueue(CurrentQueueSize)
  Else
    ReDim SendQueue(0)
    CurrentQueueSize = -1
  End If
End Function

'Public Sub cdtDraw(ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal Card As Long, ByVal Types As Long, ByVal Color As Long)
'  LoadResPicture
'End Sub


Private Function GetCardID(Suit As CardSuit, Face As CardFace) As Long
  GetCardID = Suit + Face * 4
End Function

Public Function CompileCard(Suit As CardSuit, Face As CardFace) As Long
  Dim S As Long
  If Suit = ecsSPADES Then
    S = 0
  ElseIf Suit = ecsHEARTS Then
    S = 13
  ElseIf Suit = ecsCLUBS Then
    S = 26
  Else
    S = 39
  End If
  If Face = ecfA Then
    S = S + 12
  Else
    S = S + Face - 1
  End If
  CompileCard = S
End Function

'Public Sub DrawCardFace(Suit As CardSuit, Face As CardFace, XTwip As Single, YTwip As Single, ObjHDC As Long, Optional Inverted As Boolean = False, Optional SizeX As Single = -1, Optional SizeY As Single = -1)
'  Dim MySizeX As Long, MySizeY As Long, MyX As Long, MyY As Long, MyInvert As Long
'
'  MySizeX = IIf(SizeX < 0, CardWidth, SizeX) / Screen.TwipsPerPixelX
'  MySizeY = IIf(SizeY < 0, CardHeight, SizeY) / Screen.TwipsPerPixelY
'
'  MyX = XTwip / Screen.TwipsPerPixelX
'  MyY = YTwip / Screen.TwipsPerPixelY
'
'  MyInvert = IIf(Inverted, 2, 0)
'
'  If SizeX < 0 And SizeY < 0 Then
'    cdtDraw ObjHDC, MyX, MyY, GetCardID(Suit, Face), MyInvert, vbWhite
'  Else
'    cdtDrawExt ObjHDC, MyX, MyY, MySizeX, MySizeY, GetCardID(Suit, Face), MyInvert, vbWhite
'  End If
'End Sub

Public Sub DrawCardFace(Suit As CardSuit, Face As CardFace, XTwip As Single, YTwip As Single, Ctrl As Control, Optional Joker As Boolean = False)
  Dim MyPic As StdPicture
  Dim PixelX As Single, PixelY As Single
  
  PixelX = Screen.TwipsPerPixelX
  PixelY = Screen.TwipsPerPixelY
  
  If Not Joker Then
    Set MyPic = LoadResPicture(5000 + GetCardID(Suit, Face), 0)
  Else
    Set MyPic = LoadResPicture(6000, 0)
  End If
  Ctrl.PaintPicture MyPic, XTwip + PixelX, YTwip + PixelY
  Ctrl.Line (XTwip + 2 * PixelX, YTwip)-(XTwip + 68 * PixelX, YTwip), vbBlack
  Ctrl.Line (XTwip, YTwip + 2 * PixelY)-(XTwip, YTwip + 93 * PixelY), vbBlack
  Ctrl.Line (XTwip + 2 * PixelX, YTwip)-(XTwip, YTwip + 2 * PixelY), vbBlack
  Ctrl.Line (XTwip + 70 * PixelX, YTwip + 2 * PixelY)-(XTwip + 70 * PixelX, YTwip + 93 * PixelY), vbBlack
  Ctrl.Line (XTwip + 68 * PixelX, YTwip)-(XTwip + 70 * PixelX, YTwip + 2 * PixelY), vbBlack
  Ctrl.Line (XTwip + 2 * PixelX, YTwip + 95 * PixelY)-(XTwip + 68 * PixelX, YTwip + 95 * PixelY), vbBlack
  Ctrl.Line (XTwip, YTwip + 93 * PixelY)-(XTwip + 2 * PixelX, YTwip + 95 * PixelY), vbBlack
  Ctrl.Line (XTwip + 68 * PixelX, YTwip + 95 * PixelY)-(XTwip + 71 * PixelX, YTwip + 92 * PixelY), vbBlack
End Sub

Public Sub SortCardID()
  Dim Pass As Byte, I As Byte, Temp As Byte
  
  For Pass = 1 To 14
    For I = 1 To 15 - Pass
      If CardsID(I) > CardsID(I + 1) Then
        Temp = CardsID(I)
        CardsID(I) = CardsID(I + 1)
        CardsID(I + 1) = Temp
      End If
    Next
  Next
End Sub

Public Function DispatchCurrentCardSuit(Optional ByVal CustomCard As Long = -1) As CardSuit
  Dim I As Long
  If CustomCard < 0 Then
    I = CardsID(CurrentCardID) \ 13
  Else
    I = CustomCard \ 13
  End If
  
  If I = 0 Then
    DispatchCurrentCardSuit = ecsSPADES
  ElseIf I = 1 Then
    DispatchCurrentCardSuit = ecsHEARTS
  ElseIf I = 2 Then
    DispatchCurrentCardSuit = ecsCLUBS
  Else
    DispatchCurrentCardSuit = ecsDIAMONDS
  End If
End Function

Public Function TranslateCard(CustomCard As Long) As String
  Dim CS As CardSuit, CF As CardFace, RV As String
  
  If CustomCard >= 52 Then
    RV = "Joker"
  Else
    CS = DispatchCurrentCardSuit(CustomCard)
    CF = DispatchCurrentCardFace(CustomCard)
    If CS = ecsCLUBS Then
      RV = "Club-"
    ElseIf CS = ecsDIAMONDS Then
      RV = "Diamond-"
    ElseIf CS = ecsHEARTS Then
      RV = "Heart-"
    ElseIf CS = ecsSPADES Then
      RV = "Spade-"
    End If
    
    If CF = ecfA Then
      RV = RV & "A"
    ElseIf CF = ecfJ Then
      RV = RV & "J"
    ElseIf CF = ecfQ Then
      RV = RV & "Q"
    ElseIf CF = ecfK Then
      RV = RV & "K"
    Else
      RV = RV & (CF + 1)
    End If
  End If
  
  TranslateCard = RV
End Function

Public Function DispatchCurrentCardFace(Optional ByVal CustomCard As Long = -1) As CardFace
  Dim I As Long
  If CustomCard < 0 Then
    I = CardsID(CurrentCardID) Mod 13
  Else
    I = CustomCard Mod 13
  End If
  
  If I = 12 Then
    DispatchCurrentCardFace = ecfA
  Else
    DispatchCurrentCardFace = I + 1
  End If
End Function

Public Sub ClearCardID()
  Dim I As Byte
  For I = 1 To 15
    CardsID(I) = 255
  Next
End Sub

Public Sub SelectCard(Placement As Integer)
  If Placement > TotalCards * 15 Then
    Placement = TotalCards * 15
  ElseIf Placement < 15 Then
    Placement = 15
  End If
  CardSelected(Placement \ 15) = Not CardSelected(Placement \ 15)
End Sub

Public Sub CallNext()
  Dim CardsThere(0 To 51) As Byte
  Dim CardsCon(0 To 51) As Byte
  Dim I As Byte, K As Byte

  CurrentPlayerID = CurrentPlayerID + IIf(ClockwiseDir, 1, -1)
  If CurrentPlayerID > CurrentPlayers Then
    CurrentPlayerID = 1
  ElseIf CurrentPlayerID <= 0 Then
    CurrentPlayerID = CurrentPlayers
  End If
  
  LockedOut = False
  
  If CurrentPlayerID = MyID Then
    MainWin.NumberPlayer.Caption = "Waiting for you."
  Else
    MainWin.NumberPlayer.Caption = "It's " & OtherPlayersName(CurrentPlayerID) & "'s turn."
  End If
End Sub

Public Sub AnalyseBuffer(Index As Integer)
  Dim StrType As String, StrReceive As String, A, I As Integer, J As Integer, StrID As Integer, StrMsg As String, MyPlot As RedoxPlot, TempStr As String

  A = Split(TransferBuffer(Index), vbCrLf)

  TransferBuffer(Index) = ""

  For J = 0 To UBound(A) - 1
    'GetQueue CStr(A(J)), Index, True
    
    StrType = Left$(A(J), 4)
    StrReceive = Mid$(A(J), 6)
    StrID = Val(Left$(StrReceive, 2))
    StrMsg = Mid$(StrReceive, 3)
  
    Select Case StrType
      Case "disc":
        If CurrentServer = ".me." Then
          Chatter.msg = Chatter.msg & vbNewLine & OtherPlayersName(Index + 1) & " has been disconnected from the server!"
          For I = 1 To CurrentPlayers - 1
            If I <> Index Then
              Enqueue "chat:00" & OtherPlayersName(Index + 1) & " has been disconnected!", I
              Enqueue "disc:", I
              'Enqueue "nump:" & CurrentPlayers, I
            End If
          Next
          MainWin.SendStart
          For I = 1 To CurrentPlayers - 1
            MainWin.CloseWinSocket I
          Next
        Else
          Chatter.msg = Chatter.msg & vbNewLine & "**" & vbTab & "You have been kicked out of the game."
          MainWin.CloseWinSocket Index
        End If
        Scores = 0
      Case "gtnm":
        If StrReceive = "" Then
          Enqueue "name:" & TempMyName, Index
        ElseIf StrReceive <> "-1" Then
          Enqueue "name:" & Format$(StrReceive, "00") & OtherPlayersName(StrID), Index
        Else
          For I = 1 To CurrentPlayers
            Enqueue "name:" & Format$(I, "00") & OtherPlayersName(I), Index
          Next
        End If
      Case "name":
        If CurrentServer = ".me." Then
          OtherPlayersName(Index + 1) = Mid$(StrReceive, 3)
          MainWin.NumberPlayer.Caption = "Player " & OtherPlayersName(Index + 1) & " Joined."
          Chatter.msg = Chatter.msg & vbNewLine & vbNewLine & "Player " & OtherPlayersName(Index + 1) & " (ID " & Index + 1 & ") joined the game." & vbNewLine
          For I = 1 To CurrentPlayers - 1
            If I <> Index Then
              Enqueue "name:" & Format$(Index + 1, "00") & OtherPlayersName(Index + 1), I
            End If
          Next
        Else
          OtherPlayersName(StrID) = StrMsg
        End If
        UpdatePlayerList
      Case "gtnp":
        Enqueue "nump:" & CurrentPlayers, Index
      Case "nump":
        CurrentPlayers = Val(StrReceive)
        Enqueue "gtnm:-1", Index
      Case "chat":
        If Left$(StrReceive, 2) <> "00" Then
          Chatter.msg = Chatter.msg & vbNewLine & OtherPlayersName(StrID) & ":" & vbTab & StrMsg
        Else
          Chatter.msg = Chatter.msg & vbNewLine & "**" & vbTab & StrMsg
        End If
      Case "scht":
        If CurrentServer = ".me." Then
          For I = 1 To CurrentPlayers - 1
            Enqueue "chat:" & StrReceive, I
          Next
          Chatter.msg = Chatter.msg & vbNewLine & OtherPlayersName(StrID) & ":" & vbTab & StrMsg
        End If
      Case "pcht":
        If CurrentServer = ".me." Then
          If StrID = 1 Then
            Chatter.msg = Chatter.msg & vbNewLine & "(" & OtherPlayersName(Index + 1) & "):" & vbTab & StrMsg
          Else
            Enqueue "pmsg:" & Format$(Index + 1, "00"), StrID - 1
          End If
        End If
      Case "pmsg":
        Chatter.msg = Chatter.msg & vbNewLine & "(" & OtherPlayersName(StrID) & "):" & vbTab & StrMsg
      Case "begn":
        DiscardCard = Val(StrReceive)
        MainWin.NewRound
        MainWin.mCardBack.Enabled = False
      Case "actn":
        MainWin.Actions.Caption = OtherPlayersName(StrID) & ": " & StrMsg
      Case "dpcd":
        DiscardCard = Val(StrReceive)
        MainWin.DrawDiscard
      Case "draw":
        If CurrentServer = ".me." Then
          DiscardCard = Val(StrReceive)
          For I = 1 To CurrentPlayers - 1
            Enqueue "dpcd:" & DiscardCard, I
            Enqueue "actn:" & Format$(Index + 1, "00") & "Discard " & TranslateCard(DiscardCard) & " and draw a card.", I
            Enqueue "next:", I
          Next
          MainWin.DrawDiscard
          MainWin.Actions.Caption = OtherPlayersName(Index + 1) & ": " & "Discard " & TranslateCard(DiscardCard) & " and draw a card."
          CallNext
        End If
      Case "gtdp":
        If CurrentServer = ".me." Then
          TempStr = "Exchange " & TranslateCard(Val(StrReceive)) & " for " & TranslateCard(DiscardCard) & "."
          MainWin.Actions.Caption = OtherPlayersName(Index + 1) & ": " & TempStr
          DiscardCard = Val(StrReceive)
          For I = 1 To CurrentPlayers - 1
            Enqueue "actn:" & Format$(Index + 1, "00") & TempStr, I
            Enqueue "dpcd:" & DiscardCard, I
            Enqueue "next:", I
          Next
          MainWin.DrawDiscard
          CallNext
        End If
      Case "next":
        CallNext
      Case "plot":
        If CurrentServer = ".me." Then
          MyPlot = CommandStrToPlot(StrReceive)
          AddPlot MyPlot
          MainWin.Actions.Caption = OtherPlayersName(Index + 1) & ": " & PlotToActionStr(MyPlot)
          For I = 1 To CurrentPlayers - 1
            Enqueue "splt:" & PlotToCommandStr(MyPlot), I
            Enqueue "actn:" & Format$(Index + 1, "00") & PlotToActionStr(MyPlot), I
            Enqueue "next:", I
          Next
          CallNext
        End If
      Case "splt":
        MyPlot = CommandStrToPlot(StrReceive)
        AddPlot MyPlot
      Case "rplt":
        MyPlot = CommandStrToPlot(Mid$(StrReceive, 4))
        Plots(Val(Left$(StrReceive, 3))) = MyPlot
        If CurrentServer = ".me." Then
          For I = 1 To CurrentPlayers - 1
            Enqueue "rplt:" & StrReceive, I
            Enqueue "next:", I
          Next
          CallNext
        End If
        Plotter.RefreshPlots
      Case "cona":
        If CurrentServer = ".me." Then
          MainWin.Actions.Caption = OtherPlayersName(Index + 1) & ": " & StrReceive & vbCrLf
          For I = 1 To CurrentPlayers - 1
            Enqueue "actn:" & Format$(Index + 1, "00") & StrReceive, I
          Next
        End If
      Case "winr":
        MainWin.NumberPlayer.Caption = OtherPlayersName(StrID) & " has won this round."
        LastWinner = StrID
        If CurrentServer = ".me." Then
          For I = 1 To CurrentPlayers - 1
            Enqueue "winr:" & StrReceive, I
            Enqueue "incp:1", I
            Enqueue "endg:", I
          Next
          I = Scores
          IncreaseScore
          MsgBox "You have lost this round. " & Scores - I & " marks are gained."
          CleanUpThem
        End If
      Case "incp":
        I = Scores
        IncreaseScore CByte(StrID)
        If I < Scores Then
          MsgBox "You have lost this round. " & Scores - I & " marks are gained."
        Else
          MsgBox "You have won this round, getting rid of " & I - Scores & " marks."
        End If
      Case "endg":
        CleanUpThem
        MainWin.mCardBack.Enabled = True
      Case "crdn":
        If StrReceive = "" Then
          If MyID = 1 Then
            Enqueue "card:01" & Format$(Index + 1, "00") & TotalCards, Index
          Else
            Enqueue "card:" & Format$(MyID, "00") & "01" & TotalCards, Index
          End If
        ElseIf StrID <> -1 Then
          If StrID = MyID Then
            Enqueue "card:" & Format$(MyID, "00") & StrMsg & TotalCards, Index
          Else
            If CurrentServer = ".me." Then
              Enqueue "crdn:" & StrReceive, StrID - 1
            End If
          End If
        Else
          If CurrentServer = ".me." Then
            For I = 1 To CurrentPlayers - 1
              Enqueue "crdn:" & Format$(Index * 100 + I + 101, "0000"), I
            Next
          End If
        End If
      Case "card":
        If MyID = Val(Left$(StrMsg, 2)) Then
          If Mid$(StrMsg, 3) <> "1" Then
            MsgBox "There are " & Mid$(StrMsg, 3) & " cards left in " & OtherPlayersName(StrID) & "'s hand."
          Else
            MsgBox "There is one card left in " & OtherPlayersName(StrID) & "'s hand."
          End If
        Else
          If CurrentServer = ".me." Then
            Enqueue "card:" & StrReceive, CInt(Val(Left$(StrMsg, 2)))
          End If
        End If
      Case "slam":
        If CurrentServer = ".me." Then
          MainWin.Actions.Caption = OtherPlayersName(Index + 1) & ": Slams."
          For I = 1 To CurrentPlayers - 1
            Enqueue "actn:" & Format$(I + 1, "00") & "Slams.", I
            Enqueue "winr:" & Format$(Index + 1, "00"), I
            Enqueue "incp:2", I
            Enqueue "endg:", I
          Next
          I = Scores
          IncreaseScore
          MsgBox "You have lost this round. " & Scores - 1 & " marks are gained."
          CleanUpThem
          MainWin.mCardBack.Enabled = True
        End If
      Case "paus":
        LockedOut = True
        Chatter.msg = Chatter.msg & vbNewLine & "** The game is paused."
      Case "resm":
        LockedOut = False
        Chatter.msg = Chatter.msg & vbNewLine & "** The game is resumed."
      Case "wscr":
        If StrReceive = "" Then
          If MyID = 1 Then
            Enqueue "scor:01" & Format$(Index + 1, "00") & Scores, Index
          Else
            Enqueue "scor:" & Format$(MyID, "00") & "01" & Scores, Index
          End If
        ElseIf StrID <> -1 Then
          If StrID = MyID Then
            Enqueue "scor:" & Format$(MyID, "00") & StrMsg & Scores, Index
          Else
            If CurrentServer = ".me." Then
              Enqueue "wscr:" & StrReceive, StrID - 1
            End If
          End If
        Else
          If CurrentServer = ".me." Then
            For I = 1 To CurrentPlayers - 1
              Enqueue "wscr:" & Format$(Index * 100 + I + 101, "0000"), I
            Next
          End If
        End If
      Case "scor":
        If MyID = Val(Left$(StrMsg, 2)) Then
          If SaveScores Then
            Print #20, OtherPlayersName(StrID)
            Print #20, Mid$(StrMsg, 3)
          Else
            MsgBox "Score of " & OtherPlayersName(StrID) & " is " & FormatREDOX(CLng(Mid$(StrMsg, 3))) & "."
          End If
        Else
          If CurrentServer = ".me." Then
            Enqueue "scor:" & StrReceive, CInt(Val(Left$(StrMsg, 2)))
          End If
        End If
      Case "info":
        If MsgBox(Replace(Replace(Replace(StrReceive, "%s", FormatREDOX(Scores)), "%n", vbNewLine), "%%", "%"), vbYesNo) = vbYes Then
          Enqueue "resp:1", 1
        Else
          Enqueue "resp:0", 1
        End If
      Case "resp":
        If CurrentServer = ".me." Then
          CVotes = CVotes + 1
          CVAgrees = CVAgrees + StrID
          If CVotes >= CurrentPlayers Then
            TempStr = "Voting result: " & Format$(CVAgrees / CurrentPlayers, "#%") & " of players agree on your proposal." & vbNewLine
            If CVAgrees * 2 > CurrentPlayers Then
              TempStr = TempStr & "Thus that is accepted."
              Chatter.msg = Chatter.msg & "Accepted"
              If LastVoteFor = "rtsc" Then
                Close #20
                Chatter.Command5.Enabled = True
                Chatter.Command3.Enabled = True
                For I = 1 To CurrentPlayers
                  J = AllScoresReload(I).iID
                  If J = 1 Then
                    Scores = AllScoresReload(I).iScore
                    Chatter.msg = Chatter.msg & vbNewLine & "Your score is restored to " & FormatREDOX(Scores)
                  Else
                    Enqueue "rtsc:" & AllScoresReload(I).iScore, J - 1
                  End If
                Next
              End If
            Else
              TempStr = TempStr & "Thus that is rejected."
              Chatter.msg = Chatter.msg & "Rejected"
              If LastVoteFor = "rtsc" Then
                Close #20
                Chatter.Command5.Enabled = True
                Chatter.Command3.Enabled = True
              End If
            End If
            MsgBox TempStr
          End If
        End If
      Case "rtsc":
        Scores = CLng(StrReceive)
        Chatter.msg = Chatter.msg & vbNewLine & "Your score is restored to " & FormatREDOX(Scores)
      Case "prod":
        If StrReceive <> "REDOX" Then
          Enqueue "chat:00Server mismatch: This is a REDOX server!", Index
          Enqueue "disc:", Index
        End If
      Case "vers":
        If Int(StrReceive / 10000) <> App.Major * 100 + App.Minor Then
          Enqueue "chat:00Version conflict: The server supports version " & App.Major & "." & App.Minor & " only!", Index
          Enqueue "disc:", Index
        End If
      Case Else
        Chatter.msg = Chatter.msg & vbNewLine & " <Unknown Command:" & StrType & ":" & StrReceive & ">"
    End Select
  Next
  MainWin.SendStart
End Sub

Public Sub UpdatePlayerList()
  Dim I As Integer, S As String
  Chatter.PlayerList.Clear
  For I = 1 To CurrentPlayers
    S = OtherPlayersName(I)
    If I = MyID Then
      S = S & " (myself)"
    End If
    If I = 1 Then
      S = S & " (server)"
    End If
    Chatter.PlayerList.AddItem S
  Next
  Chatter.PlayerList.ListIndex = Chatter.PlayerList.ListCount - 1
End Sub

Public Sub CleanUpThem()
  CurrentCardID = 0
  Erase CardsID
  Erase CardSelected
  DiscardCard = 0
  DrawCard = 0
  TotalSelected = 0
  HavePlot = 0
  Erase Plots
  NumOfPlot = 0
  CurrentPlayerID = 0
  MainWin.Picture3.Cls
  MainWin.Picture1.Cls
  MainWin.Picture1.Enabled = False
  Plotter.List1.Clear
  RoundPlaying = False
End Sub

Public Sub AddPlot(MyPlot As RedoxPlot)
  NumOfPlot = NumOfPlot + 1
  Plots(NumOfPlot) = MyPlot
  Plotter.RefreshPlots
End Sub

Public Function PlotToCommandStr(MyPlot As RedoxPlot) As String
  Dim S As String, SS As String
  
  If MyPlot.PlotType = eptMultiple Then
    S = "1" & Hex$(MyPlot.MultipleFace) & MyPlot.CardNum
  Else
    S = "0" & MyPlot.RoyalSuit & Hex$(MyPlot.RoyalLow) & Hex$(MyPlot.RoyalHigh)
  End If
  
  PlotToCommandStr = S
End Function

Public Function CardSuitToStr(MyCardSuit As CardSuit) As String
  Dim S As String
  Select Case MyCardSuit
    Case ecsCLUBS: S = "Clubs"
    Case ecsDIAMONDS: S = "Diamonds"
    Case ecsHEARTS: S = "Hearts"
    Case ecsSPADES: S = "Spades"
  End Select
  CardSuitToStr = S
End Function

Public Function CardFaceToStr(MyCardFace As CardFace) As String
  If MyCardFace = ecfA Then
    CardFaceToStr = "A"
  Else
    CardFaceToStr = Mid$(TranslateCard(MyCardFace - 1), 7)
  End If
End Function

Public Function PlotToActionStr(MyPlot As RedoxPlot) As String
  Dim S As String
  
  S = "Plot a "
  
  If MyPlot.PlotType = eptMultiple Then
    S = S & "mutiple of " & CardFaceToStr(MyPlot.MultipleFace) & " with " & MyPlot.CardNum & " cards."
  Else
    S = S & "royal flush of " & CardSuitToStr(MyPlot.RoyalSuit) & " from " & CardFaceToStr(MyPlot.RoyalLow) & " to " & CardFaceToStr(MyPlot.RoyalHigh) & "."
  End If
  PlotToActionStr = S
End Function

Public Function CommandStrToPlot(MyStr As String) As RedoxPlot
  Dim MyPlot As RedoxPlot
  If Left$(MyStr, 1) = "1" Then
    MyPlot.PlotType = eptMultiple
    MyPlot.MultipleFace = Val("&H" & Mid$(MyStr, 2, 1))
    MyPlot.CardNum = Val(Mid$(MyStr, 3))
  Else
    MyPlot.PlotType = eptRoyalFlush
    MyPlot.RoyalSuit = Val(Mid$(MyStr, 2, 1))
    MyPlot.RoyalLow = Val("&H" & Mid$(MyStr, 3, 1))
    MyPlot.RoyalHigh = Val("&H" & Mid$(MyStr, 4))
  End If
  CommandStrToPlot = MyPlot
End Function

Public Function ConnectToActionStr(MyPlot As RedoxPlot, CTo As Integer) As String
  Dim S As String
  S = "Connect "
  If MyPlot.PlotType = eptUndefinied Then
    S = S & "a " & CardSuitToStr(MyPlot.RoyalSuit) & "-" & CardFaceToStr(MyPlot.MultipleFace)
  ElseIf MyPlot.PlotType = eptRoyalFlush Then
    S = S & "a royal flush of " & CardSuitToStr(MyPlot.RoyalSuit) & " from " & CardFaceToStr(MyPlot.RoyalLow) & " to " & CardFaceToStr(MyPlot.RoyalHigh)
  ElseIf MyPlot.PlotType = eptMultiple Then
    S = S & "a multiple of " & CardSuitToStr(MyPlot.MultipleFace) & " with " & MyPlot.CardNum & " cards"
  End If
  S = S & " to plot #" & Format$(CTo, "000")
  ConnectToActionStr = S
End Function

Public Sub IncreaseScore(Optional Multiple As Byte = 1)
  Dim L As Long, I As Integer
  L = 0
  If TotalCards <= 0 Then
    Scores = Scores - 10
  Else
    For I = 1 To TotalCards
      If CardsID(I) < 52 Then
        Select Case CardsID(I) Mod 13
          Case 0 To 7: L = L + (CardsID(I) Mod 13) + 2
          Case 8 To 11: L = L + 10
          Case 12: L = L + 20
        End Select
      Else
        L = L + 50
      End If
    Next
    Scores = Scores + L * Multiple
  End If
End Sub

Public Function CallForPlot() As RedoxPlot
  Dim I As Integer
  Dim FirstCard As Byte
  Dim Jokers As Integer
  Dim MyPlot As RedoxPlot
  Dim RFlushes As String, RFlushes2 As String
  
  RFlushes = "0000000000000"
  
  FirstCard = 255
  Jokers = 0
  
  MyPlot.RoyalSuit = ecsUNKNOWN
  MyPlot.CardNum = -1
  
  For I = 1 To TotalCards
    If CardSelected(I) Then
      If FirstCard = 255 Then
        If CardsID(I) < 52 Then
          FirstCard = CardsID(I)
        Else
          Jokers = Jokers + 1
        End If
      Else
        If CardsID(I) >= 52 Then
          Jokers = Jokers + 1
        ElseIf MyPlot.PlotType = eptUndefinied Then
          If CardsID(I) Mod 13 = FirstCard Mod 13 Then
            MyPlot.PlotType = eptMultiple
            MyPlot.MultipleFace = DispatchCurrentCardFace(FirstCard)
            If FirstCard \ 13 = CardsID(I) \ 13 Then
              MyPlot.RoyalSuit = DispatchCurrentCardSuit(FirstCard)
            End If
            MyPlot.CardNum = 2
          ElseIf CardsID(I) \ 13 = FirstCard \ 13 Then
            MyPlot.PlotType = eptRoyalFlush
            MyPlot.RoyalSuit = DispatchCurrentCardSuit(FirstCard)
            MyPlot.CardNum = 0
            
            Mid$(RFlushes, FirstCard Mod 13 + 1, 1) = "1"
            If CardsID(I) Mod 13 <> FirstCard Mod 13 Or CardsID(I) Mod 13 = 12 Then
              Mid$(RFlushes, CardsID(I) Mod 13 + 1, 1) = CInt(Mid$(RFlushes, CardsID(I) Mod 13 + 1, 1)) + 1
            End If
          End If  'If CardsID(I) Mod 13 = FirstCard Mod 13
        ElseIf MyPlot.PlotType = eptMultiple Then
          If CardsID(I) Mod 13 <> FirstCard Mod 13 Then
            If FirstCard Mod 13 = 12 And DispatchCurrentCardSuit(CardsID(I)) = MyPlot.RoyalSuit And CardsID(I) Mod 13 <> 12 And MyPlot.CardNum = 2 Then
              MyPlot.PlotType = eptRoyalFlush
              RFlushes = "0000000000002"
              Mid$(RFlushes, CardsID(I) Mod 13 + 1, 1) = "1"
            Else
              MyPlot.CardNum = -1
              Exit Function
            End If  'If (I mistaken royal flush as multiple)
          Else
            MyPlot.CardNum = MyPlot.CardNum + 1
          End If 'If CardsID(I) Mod 13 <> FirstCard Mod 13
        ElseIf MyPlot.PlotType = eptRoyalFlush Then
          If CardsID(I) \ 13 <> FirstCard \ 13 Then
            MyPlot.CardNum = -1
            Exit Function
          Else
            Mid$(RFlushes, CardsID(I) Mod 13 + 1, 1) = CInt(Mid$(RFlushes, CardsID(I) Mod 13 + 1, 1)) + 1
          End If  'If CardsID(I) \ 13 <> FirstCard \ 13
        End If  'If MyPlot.PlotType = eptUndefinied
      End If  'If FirstCard = 255
    End If  'If CardSelected(I)
  Next  'For I = 1 To TotalCards
  
  If MyPlot.PlotType = eptRoyalFlush Then
    If InStrRev(RFlushes, "2") > 1 Then
      MyPlot.CardNum = -1
      Exit Function
    Else
      If RFlushes = "1111111111111" Then
        If Jokers = 1 Then
          RFlushes = "1111111111112"
          Jokers = 0
        ElseIf Jokers > 1 Then
          MyPlot.CardNum = -1
          Exit Function
        End If
      End If
      
      Do While Jokers > 0 And InStrRev(RFlushes, "01") > 0
        If Left$(RFlushes, 1) = "1" Then
          Mid$(RFlushes, InStr(1, RFlushes, "01"), 2) = "11"
        Else
          Mid$(RFlushes, InStrRev(RFlushes, "01"), 2) = "11"
        End If
        Jokers = Jokers - 1
      Loop
      
      Do While Jokers > 0 And InStrRev(RFlushes, "10")
        Mid$(RFlushes, InStrRev(RFlushes, "10"), 2) = "11"
        Jokers = Jokers - 1
      Loop
      
      If Jokers > 0 Then
        MyPlot.CardNum = -1
        Exit Function
      End If
      
      If Right$(RFlushes, 1) = "2" Then
        RFlushes = "1" & Left$(RFlushes, 12) & "1"
      ElseIf Left$(RFlushes, 1) = "1" And Right$(RFlushes, 1) = "1" Then
        RFlushes = "1" & Left$(RFlushes, 12) & "0"
      Else
        RFlushes = "0" & RFlushes
      End If
      
      If Left$(RFlushes, 1) = "1" And Right$(RFlushes, 1) = "1" Then
        If InStrRev(RFlushes, "0") > 0 Then
          MyPlot.CardNum = -1
          Exit Function
        Else
          MyPlot.RoyalLow = ecfA
          MyPlot.RoyalHigh = ecfA
        End If
      ElseIf Left$(RFlushes, 1) = "1" And Right$(RFlushes, 1) = "0" Then
        If InStrRev(Replace(RFlushes, "10", "~", , 1), "10") > 0 Then
          MyPlot.CardNum = -1
          Exit Function
        Else
          MyPlot.RoyalLow = ecfA
          MyPlot.RoyalHigh = InStrRev(RFlushes, "10") - 1
        End If
      ElseIf Left$(RFlushes, 1) = "0" And Right$(RFlushes, 1) = "1" Then
        If InStrRev(Replace(RFlushes, "01", "~", , 1), "01") > 0 Then
          MyPlot.CardNum = -1
          Exit Function
        Else
          MyPlot.RoyalLow = InStrRev(RFlushes, "01")
          MyPlot.RoyalHigh = ecfA
        End If
      Else
        If InStrRev(Replace(RFlushes, "01", "~", , 1), "01") > 0 Or InStrRev(Replace(RFlushes, "10", "~", , 1), "10") > 0 Then
          MyPlot.CardNum = -1
          Exit Function
        Else
          MyPlot.RoyalLow = InStrRev(RFlushes, "01")
          MyPlot.RoyalHigh = InStrRev(RFlushes, "10") - 1
        End If
      End If  'If Left$(RFlushes, 1) = "1" And Right$(RFlushes, 1) = "1"
    End If  'InStrRev(RFlushes, "2") > 1 Then
  ElseIf MyPlot.PlotType = eptMultiple Then
    MyPlot.CardNum = MyPlot.CardNum + Jokers
  ElseIf MyPlot.PlotType = eptUndefinied Then
    If FirstCard < 255 Then
      MyPlot.MultipleFace = DispatchCurrentCardFace(FirstCard)
      MyPlot.RoyalSuit = DispatchCurrentCardSuit(FirstCard)
      MyPlot.CardNum = Jokers + 1
    Else
      MyPlot.RoyalSuit = ecsUNKNOWN
      MyPlot.CardNum = Jokers
    End If
  End If 'If MyPlot.PlotType = eptRoyalFlush
  CallForPlot = MyPlot
End Function

Public Function FindName(sName As String) As Integer
  Dim I As Integer
  For I = 1 To CurrentPlayers
    If OtherPlayersName(I) = sName Then
      FindName = I
      Exit Function
    End If
  Next
  FindName = -1
End Function

Public Function FormatREDOX(tScore As Long) As String
  If tScore <= 0 Then
    FormatREDOX = tScore
  Else
    FormatREDOX = "+" & tScore
  End If
End Function
  
